#ifndef EFL_IO_FILE_EO_HH
#define EFL_IO_FILE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_file.eo.h"
#include "efl_io_closer.eo.h"
#include "efl_io_closer_fd.eo.h"
#include "efl_io_file.eo.h"
#include "efl_io_positioner.eo.h"
#include "efl_io_positioner_fd.eo.h"
#include "efl_io_reader.eo.h"
#include "efl_io_reader_fd.eo.h"
#include "efl_io_sizer.eo.h"
#include "efl_io_sizer_fd.eo.h"
#include "efl_io_writer.eo.h"
#include "efl_io_writer_fd.eo.h"
#include "efl_loop.eo.h"
#include "efl_loop_fd.eo.h"
#include "efl_loop_user.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_file.eo.hh"
#include "efl_io_closer.eo.hh"
#include "efl_io_closer_fd.eo.hh"
#include "efl_io_positioner.eo.hh"
#include "efl_io_positioner_fd.eo.hh"
#include "efl_io_reader.eo.hh"
#include "efl_io_reader_fd.eo.hh"
#include "efl_io_sizer.eo.hh"
#include "efl_io_sizer_fd.eo.hh"
#include "efl_io_writer.eo.hh"
#include "efl_io_writer_fd.eo.hh"
#include "efl_loop.eo.hh"
#include "efl_loop_fd.eo.hh"
#include "efl_loop_user.eo.hh"
#include "efl_object.eo.hh"
namespace efl { namespace io { 
struct File;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::File> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct File;
} } 
namespace efl { namespace loop { 
struct Fd;
} } 
namespace efl { 
struct Loop_User;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Loop;
} 
namespace efl { 
struct File;
} 
namespace efl { namespace io { namespace reader { 
struct Fd;
} } } 
namespace efl { namespace io { 
struct Reader;
} } 
namespace efl { namespace io { namespace writer { 
struct Fd;
} } } 
namespace efl { namespace io { 
struct Writer;
} } 
namespace efl { namespace io { namespace closer { 
struct Fd;
} } } 
namespace efl { namespace io { 
struct Closer;
} } 
namespace efl { namespace io { namespace sizer { 
struct Fd;
} } } 
namespace efl { namespace io { 
struct Sizer;
} } 
namespace efl { namespace io { namespace positioner { 
struct Fd;
} } } 
namespace efl { namespace io { 
struct Positioner;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct File {
   ::efl::eolian::return_traits< uint32_t>::type flags_get() const;
   ::efl::eolian::return_traits<void>::type flags_set( ::efl::eolian::in_traits< uint32_t>::type flags) const;
   ::efl::eolian::return_traits< uint32_t>::type mode_get() const;
   ::efl::eolian::return_traits<void>::type mode_set( ::efl::eolian::in_traits< uint32_t>::type mode) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_FILE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::File() const;
   operator ::efl::io::File&();
   operator ::efl::io::File const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<File,  ::efl::File,  ::efl::Loop_User,  ::efl::Object,  ::efl::io::Closer,  ::efl::io::Positioner,  ::efl::io::Reader,  ::efl::io::Sizer,  ::efl::io::Writer,  ::efl::io::closer::Fd,  ::efl::io::positioner::Fd,  ::efl::io::reader::Fd,  ::efl::io::sizer::Fd,  ::efl::io::writer::Fd,  ::efl::loop::Fd> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<File const ,  ::efl::File const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::io::Closer const ,  ::efl::io::Positioner const ,  ::efl::io::Reader const ,  ::efl::io::Sizer const ,  ::efl::io::Writer const ,  ::efl::io::closer::Fd const ,  ::efl::io::positioner::Fd const ,  ::efl::io::reader::Fd const ,  ::efl::io::sizer::Fd const ,  ::efl::io::writer::Fd const ,  ::efl::loop::Fd const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct File : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl ::io::Closer)
   , EO_CXX_INHERIT( ::efl ::io::Positioner)
   , EO_CXX_INHERIT( ::efl ::io::Reader)
   , EO_CXX_INHERIT( ::efl ::io::Sizer)
   , EO_CXX_INHERIT( ::efl ::io::Writer)
   , EO_CXX_INHERIT( ::efl ::io ::closer::Fd)
   , EO_CXX_INHERIT( ::efl ::io ::positioner::Fd)
   , EO_CXX_INHERIT( ::efl ::io ::reader::Fd)
   , EO_CXX_INHERIT( ::efl ::io ::sizer::Fd)
   , EO_CXX_INHERIT( ::efl ::io ::writer::Fd)
   , EO_CXX_INHERIT( ::efl ::loop::Fd)
{
   explicit File( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit File(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   File(File const& other) = default;
   File(File&& other) = default;
   File& operator=(File const& other) = default;
   File& operator=(File&& other) = default;
   File()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   File( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> File(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< uint32_t>::type flags_get() const;
   ::efl::eolian::return_traits<void>::type flags_set( ::efl::eolian::in_traits< uint32_t>::type flags) const;
   ::efl::eolian::return_traits< uint32_t>::type mode_get() const;
   ::efl::eolian::return_traits<void>::type mode_set( ::efl::eolian::in_traits< uint32_t>::type mode) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_FILE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<File,  ::efl::File,  ::efl::Loop_User,  ::efl::Object,  ::efl::io::Closer,  ::efl::io::Positioner,  ::efl::io::Reader,  ::efl::io::Sizer,  ::efl::io::Writer,  ::efl::io::closer::Fd,  ::efl::io::positioner::Fd,  ::efl::io::reader::Fd,  ::efl::io::sizer::Fd,  ::efl::io::writer::Fd,  ::efl::loop::Fd> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<File const ,  ::efl::File const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::io::Closer const ,  ::efl::io::Positioner const ,  ::efl::io::Reader const ,  ::efl::io::Sizer const ,  ::efl::io::Writer const ,  ::efl::io::closer::Fd const ,  ::efl::io::positioner::Fd const ,  ::efl::io::reader::Fd const ,  ::efl::io::sizer::Fd const ,  ::efl::io::writer::Fd const ,  ::efl::loop::Fd const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(File) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<File>::value, "");
} } 
#endif
