#ifndef EFL_VG_SHAPE_EO_HH
#define EFL_VG_SHAPE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx.eo.h"
#include "efl_gfx_path.eo.h"
#include "efl_gfx_shape.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_object.eo.h"
#include "efl_vg.eo.h"
#include "efl_vg_shape.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_gfx.eo.hh"
#include "efl_gfx_path.eo.hh"
#include "efl_gfx_shape.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_object.eo.hh"
#include "efl_vg.eo.hh"
namespace efl { namespace vg { 
struct Shape;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::vg::Shape> : ::std::true_type {}; } }
namespace efl { namespace vg { 
struct Shape;
} } 
namespace efl { 
struct VG;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Gfx;
} 
namespace efl { namespace gfx { 
struct Stack;
} } 
namespace efl { namespace gfx { 
struct Shape;
} } 
namespace efl { namespace gfx { 
struct Path;
} } 

namespace eo_cxx {
namespace efl { namespace vg { 
struct Shape {
   ::efl::eolian::return_traits< ::efl::VG>::type fill_get() const;
   ::efl::eolian::return_traits<void>::type fill_set( ::efl::eolian::in_traits< ::efl::VG>::type f) const;
   ::efl::eolian::return_traits< ::efl::VG>::type stroke_fill_get() const;
   ::efl::eolian::return_traits<void>::type stroke_fill_set( ::efl::eolian::in_traits< ::efl::VG>::type f) const;
   ::efl::eolian::return_traits< ::efl::VG>::type stroke_marker_get() const;
   ::efl::eolian::return_traits<void>::type stroke_marker_set( ::efl::eolian::in_traits< ::efl::VG>::type m) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_VG_SHAPE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::vg::Shape() const;
   operator ::efl::vg::Shape&();
   operator ::efl::vg::Shape const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Shape,  ::efl::Gfx,  ::efl::Object,  ::efl::VG,  ::efl::gfx::Path,  ::efl::gfx::Shape,  ::efl::gfx::Stack> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Shape const ,  ::efl::Gfx const ,  ::efl::Object const ,  ::efl::VG const ,  ::efl::gfx::Path const ,  ::efl::gfx::Shape const ,  ::efl::gfx::Stack const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace vg { 
struct Shape : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl::VG)
   , EO_CXX_INHERIT( ::efl ::gfx::Path)
   , EO_CXX_INHERIT( ::efl ::gfx::Shape)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
{
   explicit Shape( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Shape(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Shape(Shape const& other) = default;
   Shape(Shape&& other) = default;
   Shape& operator=(Shape const& other) = default;
   Shape& operator=(Shape&& other) = default;
   Shape()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Shape( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Shape(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::VG>::type fill_get() const;
   ::efl::eolian::return_traits<void>::type fill_set( ::efl::eolian::in_traits< ::efl::VG>::type f) const;
   ::efl::eolian::return_traits< ::efl::VG>::type stroke_fill_get() const;
   ::efl::eolian::return_traits<void>::type stroke_fill_set( ::efl::eolian::in_traits< ::efl::VG>::type f) const;
   ::efl::eolian::return_traits< ::efl::VG>::type stroke_marker_get() const;
   ::efl::eolian::return_traits<void>::type stroke_marker_set( ::efl::eolian::in_traits< ::efl::VG>::type m) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_VG_SHAPE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Shape,  ::efl::Gfx,  ::efl::Object,  ::efl::VG,  ::efl::gfx::Path,  ::efl::gfx::Shape,  ::efl::gfx::Stack> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Shape const ,  ::efl::Gfx const ,  ::efl::Object const ,  ::efl::VG const ,  ::efl::gfx::Path const ,  ::efl::gfx::Shape const ,  ::efl::gfx::Stack const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Shape) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Shape>::value, "");
} } 
#endif
