#ifndef EVAS_CANVAS_EO_HH
#define EVAS_CANVAS_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_gfx.eo.h"
#include "efl_input_device.eo.h"
#include "efl_input_focus.eo.h"
#include "efl_input_hold.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_input_key.eo.h"
#include "efl_input_pointer.eo.h"
#include "efl_loop.eo.h"
#include "efl_loop_user.eo.h"
#include "efl_object.eo.h"
#include "evas_canvas.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_input_device.eo.hh"
#include "efl_input_focus.eo.hh"
#include "efl_input_hold.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_input_key.eo.hh"
#include "efl_input_pointer.eo.hh"
#include "efl_loop.eo.hh"
#include "efl_loop_user.eo.hh"
#include "efl_object.eo.hh"
namespace evas { 
struct Canvas;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::Canvas> : ::std::true_type {}; } }
namespace evas { 
struct Canvas;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Canvas;
} 
namespace efl { namespace input { 
struct Device;
} } 
namespace efl { 
struct Gfx;
} 
namespace efl { namespace input { 
struct Focus;
} } 
namespace efl { 
struct Animator;
} 
namespace efl { namespace input { 
struct Interface;
} } 
namespace efl { namespace input { 
struct Pointer;
} } 
namespace efl { namespace input { 
struct Key;
} } 
namespace efl { namespace input { 
struct Hold;
} } 
namespace efl { 
struct Loop_User;
} 
namespace efl { 
struct Loop;
} 
namespace efl { namespace canvas { 
struct Object;
} } 

namespace eo_cxx {
namespace evas { 
struct Canvas {
   ::efl::eolian::return_traits<int>::type image_cache_get() const;
   ::efl::eolian::return_traits<void>::type image_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<Efl_Input_Flags>::type event_default_flags_get() const;
   ::efl::eolian::return_traits<void>::type event_default_flags_set( ::efl::eolian::in_traits<Efl_Input_Flags>::type flags) const;
   ::efl::eolian::return_traits<int>::type font_cache_get() const;
   ::efl::eolian::return_traits<void>::type font_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<void*>::type data_attach_get() const;
   ::efl::eolian::return_traits<void>::type data_attach_set( ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type focus_get() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type seat_focus_get( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_top_get() const;
   ::efl::eolian::return_traits<void>::type pointer_canvas_xy_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type pointer_canvas_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<int>::type event_down_count_get() const;
   ::efl::eolian::return_traits<int>::type smart_objects_calculate_count_get() const;
   ::efl::eolian::return_traits<bool>::type focus_state_get() const;
   ::efl::eolian::return_traits<bool>::type seat_focus_state_get( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<bool>::type changed_get() const;
   ::efl::eolian::return_traits<void>::type pointer_output_xy_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type pointer_output_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<bool>::type pointer_inside_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev) const;
   ::efl::eolian::return_traits<bool>::type pointer_inside_get() const;
   ::efl::eolian::return_traits<bool>::type image_max_size_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_bottom_get() const;
   ::efl::eolian::return_traits< unsigned int>::type pointer_button_down_mask_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev) const;
   ::efl::eolian::return_traits< unsigned int>::type pointer_button_down_mask_get() const;
   ::efl::eolian::return_traits<bool>::type smart_objects_calculating_get() const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type default_device_get( ::efl::eolian::in_traits<Efl_Input_Device_Type>::type type) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type tree_objects_at_xy_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type stop,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type key_lock_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type seat_key_lock_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type seat_key_lock_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type key_modifier_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type key_modifier_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type objects_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits<bool>::type render_async() const;
   ::efl::eolian::return_traits<bool>::type render2() const;
   ::efl::eolian::return_traits<  ::efl::eina::list<Eina_Rectangle const&>>::type render2_updates() const;
   ::efl::eolian::return_traits<void>::type focus_out() const;
   ::efl::eolian::return_traits<void>::type norender() const;
   ::efl::eolian::return_traits<void>::type nochange_pop() const;
   ::efl::eolian::return_traits<void>::type key_lock_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type nochange_push() const;
   ::efl::eolian::return_traits<void>::type font_cache_flush() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_top_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits<void>::type key_modifier_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type seat_key_modifier_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type seat_key_modifier_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::eina::string_view>>::type font_available_list() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type objects_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<void>::type font_path_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   ::efl::eolian::return_traits<void>::type font_path_clear() const;
   ::efl::eolian::return_traits<void>::type smart_objects_calculate() const;
   ::efl::eolian::return_traits<void>::type touch_point_list_nth_xy_get( ::efl::eolian::in_traits< unsigned int>::type n,  ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   ::efl::eolian::return_traits<void>::type key_lock_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type damage_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type sync() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::eina::string_view>>::type font_path_list() const;
   ::efl::eolian::return_traits<void>::type image_cache_reload() const;
   ::efl::eolian::return_traits<int>::type coord_world_x_to_screen( ::efl::eolian::in_traits<int>::type x) const;
   ::efl::eolian::return_traits<  ::efl::eina::list<Eina_Rectangle const&>>::type render_updates() const;
   ::efl::eolian::return_traits<void>::type image_cache_flush() const;
   ::efl::eolian::return_traits<int>::type coord_screen_y_to_world( ::efl::eolian::in_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type key_modifier_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type focus_in() const;
   ::efl::eolian::return_traits<void>::type seat_focus_in( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type seat_focus_out( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type obscured_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type render_dump() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_top_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits<void>::type render() const;
   ::efl::eolian::return_traits<void>::type font_path_prepend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   ::efl::eolian::return_traits<void>::type obscured_clear() const;
   ::efl::eolian::return_traits<int>::type coord_screen_x_to_world( ::efl::eolian::in_traits<int>::type x) const;
   ::efl::eolian::return_traits<void>::type key_lock_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type render_idle_flush() const;
   ::efl::eolian::return_traits<int>::type coord_world_y_to_screen( ::efl::eolian::in_traits<int>::type y) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::Canvas() const;
   operator ::evas::Canvas&();
   operator ::evas::Canvas const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Canvas,  ::efl::Animator,  ::efl::Canvas,  ::efl::Loop_User,  ::efl::Object,  ::efl::input::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Canvas const ,  ::efl::Animator const ,  ::efl::Canvas const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::input::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace evas { 
struct Canvas : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Canvas)
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
{
   explicit Canvas( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Canvas(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Canvas(Canvas const& other) = default;
   Canvas(Canvas&& other) = default;
   Canvas& operator=(Canvas const& other) = default;
   Canvas& operator=(Canvas&& other) = default;
   Canvas()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Canvas( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Canvas(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type image_cache_get() const;
   ::efl::eolian::return_traits<void>::type image_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<Efl_Input_Flags>::type event_default_flags_get() const;
   ::efl::eolian::return_traits<void>::type event_default_flags_set( ::efl::eolian::in_traits<Efl_Input_Flags>::type flags) const;
   ::efl::eolian::return_traits<int>::type font_cache_get() const;
   ::efl::eolian::return_traits<void>::type font_cache_set( ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<void*>::type data_attach_get() const;
   ::efl::eolian::return_traits<void>::type data_attach_set( ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type focus_get() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type seat_focus_get( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_top_get() const;
   ::efl::eolian::return_traits<void>::type pointer_canvas_xy_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type pointer_canvas_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<int>::type event_down_count_get() const;
   ::efl::eolian::return_traits<int>::type smart_objects_calculate_count_get() const;
   ::efl::eolian::return_traits<bool>::type focus_state_get() const;
   ::efl::eolian::return_traits<bool>::type seat_focus_state_get( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<bool>::type changed_get() const;
   ::efl::eolian::return_traits<void>::type pointer_output_xy_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type pointer_output_xy_get( ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y) const;
   ::efl::eolian::return_traits<bool>::type pointer_inside_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev) const;
   ::efl::eolian::return_traits<bool>::type pointer_inside_get() const;
   ::efl::eolian::return_traits<bool>::type image_max_size_get( ::efl::eolian::out_traits<int>::type maxw,  ::efl::eolian::out_traits<int>::type maxh) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_bottom_get() const;
   ::efl::eolian::return_traits< unsigned int>::type pointer_button_down_mask_by_device_get( ::efl::eolian::in_traits< ::efl::input::Device>::type dev) const;
   ::efl::eolian::return_traits< unsigned int>::type pointer_button_down_mask_get() const;
   ::efl::eolian::return_traits<bool>::type smart_objects_calculating_get() const;
   ::efl::eolian::return_traits< ::efl::input::Device>::type default_device_get( ::efl::eolian::in_traits<Efl_Input_Device_Type>::type type) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type tree_objects_at_xy_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type stop,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type key_lock_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type seat_key_lock_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type seat_key_lock_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type key_modifier_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type key_modifier_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type objects_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits<bool>::type render_async() const;
   ::efl::eolian::return_traits<bool>::type render2() const;
   ::efl::eolian::return_traits<  ::efl::eina::list<Eina_Rectangle const&>>::type render2_updates() const;
   ::efl::eolian::return_traits<void>::type focus_out() const;
   ::efl::eolian::return_traits<void>::type norender() const;
   ::efl::eolian::return_traits<void>::type nochange_pop() const;
   ::efl::eolian::return_traits<void>::type key_lock_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type nochange_push() const;
   ::efl::eolian::return_traits<void>::type font_cache_flush() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_top_at_xy_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits<void>::type key_modifier_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type seat_key_modifier_on( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type seat_key_modifier_off( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname,  ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::eina::string_view>>::type font_available_list() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::canvas::Object>>::type objects_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
   ::efl::eolian::return_traits<void>::type font_path_append( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   ::efl::eolian::return_traits<void>::type font_path_clear() const;
   ::efl::eolian::return_traits<void>::type smart_objects_calculate() const;
   ::efl::eolian::return_traits<void>::type touch_point_list_nth_xy_get( ::efl::eolian::in_traits< unsigned int>::type n,  ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   ::efl::eolian::return_traits<void>::type key_lock_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type damage_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type sync() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::efl::eina::string_view>>::type font_path_list() const;
   ::efl::eolian::return_traits<void>::type image_cache_reload() const;
   ::efl::eolian::return_traits<int>::type coord_world_x_to_screen( ::efl::eolian::in_traits<int>::type x) const;
   ::efl::eolian::return_traits<  ::efl::eina::list<Eina_Rectangle const&>>::type render_updates() const;
   ::efl::eolian::return_traits<void>::type image_cache_flush() const;
   ::efl::eolian::return_traits<int>::type coord_screen_y_to_world( ::efl::eolian::in_traits<int>::type y) const;
   ::efl::eolian::return_traits<void>::type key_modifier_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type focus_in() const;
   ::efl::eolian::return_traits<void>::type seat_focus_in( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type seat_focus_out( ::efl::eolian::in_traits< ::efl::input::Device>::type seat) const;
   ::efl::eolian::return_traits<void>::type obscured_rectangle_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type render_dump() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type object_top_in_rectangle_get( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h,  ::efl::eolian::in_traits<bool>::type include_pass_events_objects,  ::efl::eolian::in_traits<bool>::type include_hidden_objects) const;
   ::efl::eolian::return_traits<void>::type render() const;
   ::efl::eolian::return_traits<void>::type font_path_prepend( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   ::efl::eolian::return_traits<void>::type obscured_clear() const;
   ::efl::eolian::return_traits<int>::type coord_screen_x_to_world( ::efl::eolian::in_traits<int>::type x) const;
   ::efl::eolian::return_traits<void>::type key_lock_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type keyname) const;
   ::efl::eolian::return_traits<void>::type render_idle_flush() const;
   ::efl::eolian::return_traits<int>::type coord_world_y_to_screen( ::efl::eolian::in_traits<int>::type y) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Canvas,  ::efl::Animator,  ::efl::Canvas,  ::efl::Loop_User,  ::efl::Object,  ::efl::input::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Canvas const ,  ::efl::Animator const ,  ::efl::Canvas const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::input::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Canvas) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Canvas>::value, "");
} 
#endif
