#ifndef EVAS_CANVAS3D_MESH_EO_HH
#define EVAS_CANVAS3D_MESH_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_file.eo.h"
#include "efl_object.eo.h"
#include "evas_canvas3d_material.eo.h"
#include "evas_canvas3d_mesh.eo.h"
#include "evas_canvas3d_object.eo.h"
#include "evas_canvas3d_primitive.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_file.eo.hh"
#include "efl_object.eo.hh"
#include "evas_canvas3d_material.eo.hh"
#include "evas_canvas3d_object.eo.hh"
#include "evas_canvas3d_primitive.eo.hh"
namespace evas { namespace canvas3d { 
struct Mesh;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Mesh> : ::std::true_type {}; } }
namespace evas { namespace canvas3d { 
struct Mesh;
} } 
namespace evas { namespace canvas3d { 
struct Object;
} } 
namespace efl { 
struct Object;
} 
namespace efl { 
struct File;
} 
namespace evas { namespace canvas3d { 
struct Material;
} } 
namespace evas { namespace canvas3d { 
struct Primitive;
} } 

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Mesh {
   ::efl::eolian::return_traits<Evas_Canvas3D_Shader_Mode>::type shader_mode_get() const;
   ::efl::eolian::return_traits<void>::type shader_mode_set( ::efl::eolian::in_traits<Evas_Canvas3D_Shader_Mode>::type mode) const;
   ::efl::eolian::return_traits<bool>::type color_pick_enable_get() const;
   ::efl::eolian::return_traits<void>::type color_pick_enable_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits< unsigned int>::type vertex_count_get() const;
   ::efl::eolian::return_traits<void>::type vertex_count_set( ::efl::eolian::in_traits< unsigned int>::type count) const;
   ::efl::eolian::return_traits<bool>::type fog_enable_get() const;
   ::efl::eolian::return_traits<void>::type fog_enable_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<bool>::type alpha_test_enable_get() const;
   ::efl::eolian::return_traits<void>::type alpha_test_enable_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<void>::type alpha_func_get( ::efl::eolian::out_traits<Evas_Canvas3D_Comparison>::type comparison_func,  ::efl::eolian::out_traits<Evas_Real>::type ref_value) const;
   ::efl::eolian::return_traits<void>::type alpha_func_set( ::efl::eolian::in_traits<Evas_Canvas3D_Comparison>::type comparison_func,  ::efl::eolian::in_traits<Evas_Real>::type ref_value) const;
   ::efl::eolian::return_traits<bool>::type blending_enable_get() const;
   ::efl::eolian::return_traits<void>::type blending_enable_set( ::efl::eolian::in_traits<bool>::type blending) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Material>::type frame_material_get( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type frame_material_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits< ::evas::canvas3d::Material>::type material) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Vertex_Assembly>::type vertex_assembly_get() const;
   ::efl::eolian::return_traits<void>::type vertex_assembly_set( ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Assembly>::type assembly) const;
   ::efl::eolian::return_traits<void>::type shadows_edges_filtering_get( ::efl::eolian::out_traits<int>::type blur_level,  ::efl::eolian::out_traits<Evas_Real>::type edges_size) const;
   ::efl::eolian::return_traits<void>::type shadows_edges_filtering_set( ::efl::eolian::in_traits<int>::type blur_level,  ::efl::eolian::in_traits<Evas_Real>::type edges_size) const;
   ::efl::eolian::return_traits<Evas_Real>::type shadows_constant_bias_get() const;
   ::efl::eolian::return_traits<void>::type shadows_constant_bias_set( ::efl::eolian::in_traits<Evas_Real>::type bias) const;
   ::efl::eolian::return_traits<void>::type lod_boundary_get( ::efl::eolian::out_traits<Evas_Real>::type near_lod,  ::efl::eolian::out_traits<Evas_Real>::type far_lod) const;
   ::efl::eolian::return_traits<void>::type lod_boundary_set( ::efl::eolian::in_traits<Evas_Real>::type near_lod,  ::efl::eolian::in_traits<Evas_Real>::type far_lod) const;
   ::efl::eolian::return_traits<void>::type frame_vertex_data_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib,  ::efl::eolian::in_traits<int>::type stride,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type frame_vertex_data_copy_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib,  ::efl::eolian::in_traits<int>::type stride,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void*>::type frame_vertex_data_map( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib) const;
   ::efl::eolian::return_traits<void>::type frame_vertex_data_unmap( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib) const;
   ::efl::eolian::return_traits<int>::type frame_vertex_stride_get( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib) const;
   ::efl::eolian::return_traits<void>::type index_data_set( ::efl::eolian::in_traits<Evas_Canvas3D_Index_Format>::type format,  ::efl::eolian::in_traits<int>::type count,  ::efl::eolian::in_traits<void const*>::type indices) const;
   ::efl::eolian::return_traits<void>::type convex_hull_data_get( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Eina_Inarray const&>::type vertex,  ::efl::eolian::in_traits<Eina_Inarray const&>::type index) const;
   ::efl::eolian::return_traits<void>::type index_data_copy_set( ::efl::eolian::in_traits<Evas_Canvas3D_Index_Format>::type format,  ::efl::eolian::in_traits<int>::type count,  ::efl::eolian::in_traits<void const*>::type indices) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Index_Format>::type index_format_get() const;
   ::efl::eolian::return_traits<int>::type index_count_get() const;
   ::efl::eolian::return_traits<void*>::type index_data_map() const;
   ::efl::eolian::return_traits<void>::type index_data_unmap() const;
   ::efl::eolian::return_traits<bool>::type frame_exist( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type frame_add( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type frame_del( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type fog_color_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   ::efl::eolian::return_traits<void>::type fog_color_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   ::efl::eolian::return_traits<void>::type blending_func_set( ::efl::eolian::in_traits<Evas_Canvas3D_Blend_Func>::type sfactor,  ::efl::eolian::in_traits<Evas_Canvas3D_Blend_Func>::type dfactor) const;
   ::efl::eolian::return_traits<void>::type blending_func_get( ::efl::eolian::out_traits<Evas_Canvas3D_Blend_Func>::type sfactor,  ::efl::eolian::out_traits<Evas_Canvas3D_Blend_Func>::type dfactor) const;
   ::efl::eolian::return_traits<void>::type from_primitive_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits< ::evas::canvas3d::Primitive>::type primitive) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_MESH_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Mesh() const;
   operator ::evas::canvas3d::Mesh&();
   operator ::evas::canvas3d::Mesh const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Mesh,  ::efl::File,  ::efl::Object,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Mesh const ,  ::efl::File const ,  ::efl::Object const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Mesh : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::File)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::evas ::canvas3d::Object)
{
   explicit Mesh( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Mesh(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Mesh(Mesh const& other) = default;
   Mesh(Mesh&& other) = default;
   Mesh& operator=(Mesh const& other) = default;
   Mesh& operator=(Mesh&& other) = default;
   Mesh()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Mesh( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Mesh(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Evas_Canvas3D_Shader_Mode>::type shader_mode_get() const;
   ::efl::eolian::return_traits<void>::type shader_mode_set( ::efl::eolian::in_traits<Evas_Canvas3D_Shader_Mode>::type mode) const;
   ::efl::eolian::return_traits<bool>::type color_pick_enable_get() const;
   ::efl::eolian::return_traits<void>::type color_pick_enable_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits< unsigned int>::type vertex_count_get() const;
   ::efl::eolian::return_traits<void>::type vertex_count_set( ::efl::eolian::in_traits< unsigned int>::type count) const;
   ::efl::eolian::return_traits<bool>::type fog_enable_get() const;
   ::efl::eolian::return_traits<void>::type fog_enable_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<bool>::type alpha_test_enable_get() const;
   ::efl::eolian::return_traits<void>::type alpha_test_enable_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<void>::type alpha_func_get( ::efl::eolian::out_traits<Evas_Canvas3D_Comparison>::type comparison_func,  ::efl::eolian::out_traits<Evas_Real>::type ref_value) const;
   ::efl::eolian::return_traits<void>::type alpha_func_set( ::efl::eolian::in_traits<Evas_Canvas3D_Comparison>::type comparison_func,  ::efl::eolian::in_traits<Evas_Real>::type ref_value) const;
   ::efl::eolian::return_traits<bool>::type blending_enable_get() const;
   ::efl::eolian::return_traits<void>::type blending_enable_set( ::efl::eolian::in_traits<bool>::type blending) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Material>::type frame_material_get( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type frame_material_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits< ::evas::canvas3d::Material>::type material) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Vertex_Assembly>::type vertex_assembly_get() const;
   ::efl::eolian::return_traits<void>::type vertex_assembly_set( ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Assembly>::type assembly) const;
   ::efl::eolian::return_traits<void>::type shadows_edges_filtering_get( ::efl::eolian::out_traits<int>::type blur_level,  ::efl::eolian::out_traits<Evas_Real>::type edges_size) const;
   ::efl::eolian::return_traits<void>::type shadows_edges_filtering_set( ::efl::eolian::in_traits<int>::type blur_level,  ::efl::eolian::in_traits<Evas_Real>::type edges_size) const;
   ::efl::eolian::return_traits<Evas_Real>::type shadows_constant_bias_get() const;
   ::efl::eolian::return_traits<void>::type shadows_constant_bias_set( ::efl::eolian::in_traits<Evas_Real>::type bias) const;
   ::efl::eolian::return_traits<void>::type lod_boundary_get( ::efl::eolian::out_traits<Evas_Real>::type near_lod,  ::efl::eolian::out_traits<Evas_Real>::type far_lod) const;
   ::efl::eolian::return_traits<void>::type lod_boundary_set( ::efl::eolian::in_traits<Evas_Real>::type near_lod,  ::efl::eolian::in_traits<Evas_Real>::type far_lod) const;
   ::efl::eolian::return_traits<void>::type frame_vertex_data_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib,  ::efl::eolian::in_traits<int>::type stride,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void>::type frame_vertex_data_copy_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib,  ::efl::eolian::in_traits<int>::type stride,  ::efl::eolian::in_traits<void const*>::type data) const;
   ::efl::eolian::return_traits<void*>::type frame_vertex_data_map( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib) const;
   ::efl::eolian::return_traits<void>::type frame_vertex_data_unmap( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib) const;
   ::efl::eolian::return_traits<int>::type frame_vertex_stride_get( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Evas_Canvas3D_Vertex_Attrib>::type attrib) const;
   ::efl::eolian::return_traits<void>::type index_data_set( ::efl::eolian::in_traits<Evas_Canvas3D_Index_Format>::type format,  ::efl::eolian::in_traits<int>::type count,  ::efl::eolian::in_traits<void const*>::type indices) const;
   ::efl::eolian::return_traits<void>::type convex_hull_data_get( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits<Eina_Inarray const&>::type vertex,  ::efl::eolian::in_traits<Eina_Inarray const&>::type index) const;
   ::efl::eolian::return_traits<void>::type index_data_copy_set( ::efl::eolian::in_traits<Evas_Canvas3D_Index_Format>::type format,  ::efl::eolian::in_traits<int>::type count,  ::efl::eolian::in_traits<void const*>::type indices) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Index_Format>::type index_format_get() const;
   ::efl::eolian::return_traits<int>::type index_count_get() const;
   ::efl::eolian::return_traits<void*>::type index_data_map() const;
   ::efl::eolian::return_traits<void>::type index_data_unmap() const;
   ::efl::eolian::return_traits<bool>::type frame_exist( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type frame_add( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type frame_del( ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits<void>::type fog_color_set( ::efl::eolian::in_traits<Evas_Real>::type r,  ::efl::eolian::in_traits<Evas_Real>::type g,  ::efl::eolian::in_traits<Evas_Real>::type b,  ::efl::eolian::in_traits<Evas_Real>::type a) const;
   ::efl::eolian::return_traits<void>::type fog_color_get( ::efl::eolian::out_traits<Evas_Real>::type r,  ::efl::eolian::out_traits<Evas_Real>::type g,  ::efl::eolian::out_traits<Evas_Real>::type b,  ::efl::eolian::out_traits<Evas_Real>::type a) const;
   ::efl::eolian::return_traits<void>::type blending_func_set( ::efl::eolian::in_traits<Evas_Canvas3D_Blend_Func>::type sfactor,  ::efl::eolian::in_traits<Evas_Canvas3D_Blend_Func>::type dfactor) const;
   ::efl::eolian::return_traits<void>::type blending_func_get( ::efl::eolian::out_traits<Evas_Canvas3D_Blend_Func>::type sfactor,  ::efl::eolian::out_traits<Evas_Canvas3D_Blend_Func>::type dfactor) const;
   ::efl::eolian::return_traits<void>::type from_primitive_set( ::efl::eolian::in_traits<int>::type frame,  ::efl::eolian::in_traits< ::evas::canvas3d::Primitive>::type primitive) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_MESH_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Mesh,  ::efl::File,  ::efl::Object,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Mesh const ,  ::efl::File const ,  ::efl::Object const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Mesh) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Mesh>::value, "");
} } 
#endif
